C - Train Problem II——(HDU 1023 Catalan 数)

简介:

传送门

Train Problem II

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7616    Accepted Submission(s): 4101


Problem Description
As we all know the Train Problem I, the boss of the Ignatius Train Station want to know if all the trains come in strict-increasing order, how many orders that all the trains can get out of the railway.
 

Input
The input contains several test cases. Each test cases consists of a number N(1<=N<=100). The input is terminated by the end of file.
 

Output
For each test case, you should output how many ways that all the trains can get out of the railway.
 

Sample Input
 
 
1 2 3 10
 

Sample Output
 
 
1 2 5 16796
Hint
The result will be very large, so you may not process it by 32-bit integers.

 
题目大意:

就是求一个卡特兰数,如果是C++的话 得用高精度,java 的话 得用 BigInteger。。。


解题思路:

只要掌握卡特兰数的公式就行了,两个公式:

1. 组合公式为 Cn = C(2n,n) / (n+1);
2. 递推公式为 h(n ) = h(n-1)*(4*n-2) / (n+1)

我们采用的是第二个,如果用java 写的话还是比较省事儿的,因为直接有个大数类,所以直接调用就行,所以我也先给一个java的代码(也是第一次写java代码 有点小紧张):

My Java Code:

<span style="font-size:18px;">import java.util.*;
import java.math.BigInteger;
public class Main {
    public static void main(String[] args) {
        BigInteger a[] = new BigInteger[105];
        a[0] = BigInteger.ZERO;
        a[1] = BigInteger.ONE;
        for(int i=2;i<=102;i++) {
            a[i] = a[i-1].multiply(BigInteger.valueOf(4*i-2)).divide(BigInteger.valueOf(i+1));
        }
        
        Scanner in = new Scanner(System.in);
        
        while(in.hasNext()) {
            int n=in.nextInt();
            System.out.println(a[n]);
        }
    }
}</span>

然后接下来就是用c++写的了,这个得用到 高精度乘法,然后采用了bin神的Catalan数模板,觉得还是比较实用的,自己也做了一点小改动,当然适合自己的才是最好的,只要理解起来容易,怎么理解方便怎么来,给一下AC 的C++代码:

My Cpp Code:

<span style="font-size:18px;">#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
const int MAXN = 105;
int a[MAXN][MAXN];
int b[MAXN];
///可以作为模板
void Catalan()
{
    int yu,len;
    a[1][0] = 1;
    a[1][1] = 1;
    len = 1;
    for(int i=2; i<MAXN; i++)
    {
        yu = 0;
        for(int j=1; j<=len; j++)
        {
            int t = (a[i-1][j])*(4*i-2) + yu;
            yu = t/10;
            a[i][j] = t%10;
        }
        while(yu)
        {
            a[i][++len] = yu%10;
            yu /= 10;
        }
        for(int j=len; j>=1; j--)
        {
            int t = a[i][j]+yu*10;
            a[i][j] = t/(i+1);
            yu = t%(i+1);
        }
        while(!a[i][len])
            len--;
        a[i][0] = len;
    }
}
int main()
{
    Catalan();
    int n;
    while(cin>>n)
    {
        for(int i=a[n][0]; i>0; i--)
        cout<<a[n][i];
        puts("");
    }
    return 0;
}
</span>






目录
相关文章
|
Java
hdu 1022 Train Problem I【模拟出入栈】
hdu 1022 Train Problem I【模拟出入栈】
56 0
hdu 1022 Train Problem I【模拟出入栈】
HDOJ/HDU 1022 Train Problem I(模拟栈)
HDOJ/HDU 1022 Train Problem I(模拟栈)
126 0
HDOJ/HDU 1022 Train Problem I(模拟栈)
HDOJ(HDU) 1898 Sempr == The Best Problem Solver?(水题、、、)
HDOJ(HDU) 1898 Sempr == The Best Problem Solver?(水题、、、)
134 0
|
人工智能
HDOJ/HDU 2710 Max Factor(素数快速筛选~)
HDOJ/HDU 2710 Max Factor(素数快速筛选~)
111 0
|
算法 Python
动态规划法(三)子集和问题(Subset sum problem)
  继续讲故事~~   上次讲到我们的主人公丁丁,用神奇的动态规划法解决了杂货店老板的两个找零钱问题,得到了老板的肯定。之后,他就决心去大城市闯荡了,看一看外面更大的世界。
2482 1
|
人工智能 Java